package mn.grapecity.mmcomponent.mm_component;

import org.json.JSONObject;

import java.util.Observable;
import java.util.Observer;

public class SharedInstance extends Observable{
    public static SharedInstance instance = new SharedInstance();

    private int status;
    private JSONObject state;

    private static synchronized SharedInstance getInstance() {
        if(instance == null) {
            instance = new SharedInstance();
        }
        return instance;
    }
    private SharedInstance() {}


    public void setState( int status, JSONObject state) {
        synchronized (this) {
            this.status =  status; // failed success
            this.state = state; // data
        }
        setChanged();
        notifyObservers();
    }

    public static void addObserverStatic(Observer observer) {
        getInstance().addObserver(observer);
    }

    public synchronized JSONObject getState() {
        return state;
    }

    public synchronized  int getStatus() {
        return status;
    }

    public static void deleteObserverStatic(Observer observer){getInstance().deleteObserver(observer);}
}