package mn.grapecity.mmcomponent.mm_component_example;

import android.os.Bundle;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Observable;
import java.util.Observer;

import io.flutter.embedding.android.FlutterActivity;
import mn.grapecity.mmcomponent.mm_component.MMLoginHelper;
import mn.grapecity.mmcomponent.mm_component.MmComponentPlugin;
import mn.grapecity.mmcomponent.mm_component.SharedInstance;

public class MainActivity extends FlutterActivity implements Observer {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        SharedInstance.instance.addObserver(MainActivity.this);
        Log.d("createshdee:", "createshdee");
    }

    @Override
    public void update(Observable obs, Object obj) {
        JSONObject data = SharedInstance.instance.getState();
        int status = SharedInstance.instance.getStatus();

        Log.d("data:", " " + data);
        Log.d("status:", " " + status);

        if (status == MMLoginHelper.RESULT_CODE_SUCCESS) {
            SharedInstance.instance.deleteObservers();
            try {
                if (data.has("biometric")) {
                    MmComponentPlugin.setBiometric(data.getBoolean("biometric"));
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            JSONObject result = new JSONObject();
            try {
                result.put("data", data);
            } catch (JSONException e) {
                e.printStackTrace();
            }

            MmComponentPlugin.hasResponse("onSuccess", result.toString());

        } else if (status == MMLoginHelper.RESULT_CODE_FAILED) {
            try {
                if (data.has("biometric")) {
                    MmComponentPlugin.setBiometric(data.getBoolean("biometric"));
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            JSONObject result = new JSONObject();
            try {
                result.put("data", data);
            } catch (JSONException e) {
                e.printStackTrace();
            }

            MmComponentPlugin.hasResponse("onFail", result.toString());
        } else if (status == MMLoginHelper.RESULT_CODE_GOTO) {

            SharedInstance.instance.deleteObservers();

            JSONObject result = new JSONObject();
            try {
                result.put("data", data);
            } catch (JSONException e) {
                e.printStackTrace();
            }

            MmComponentPlugin.hasResponse("onGoto", result.toString());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
