import 'package:flutter/material.dart';
import 'dart:async';

import 'package:mm_component/mm_component.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String response = '';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  Future<void> initPlatformState() async {
    await MmComponent.navigate(
      operation: MmComponent.KEY_NAVIGATION_LOGIN,
      version: "60",
      url: "http://172.16.116.92:8081",
      onError: onError,
      onSuccess: onSuccess,
      onGoto: onGoto,
    );
  }

  void onSuccess(String result) {
    setState(() {
      response = "onSuccess: $result";
    });
  }

  void onError(String result) {
    setState(() {
      response = "onError: $result";
    });
  }

  void onGoto(String result) {
    setState(() {
      response = "onGoto: $result";
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('MM Component plugin example app'),
        ),
        body: Center(
          child: Text('Response: $response\n'),
        ),
      ),
    );
  }
}
