import 'dart:async';
import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class MmComponent {
  static const MethodChannel _channel = const MethodChannel('mm_component');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static const KEY_BIOMETRIC_STATUS = "KEY_BIOMETRIC_STATUS";
  static const KEY_NAVIGATION_CHANGEPIN = "KEY_NAVIGATION_CHANGEPIN";
  static const KEY_NAVIGATION_PIN = "KEY_NAVIGATION_PIN";
  static const KEY_NAVIGATION_CHANGEMOBILE = "KEY_NAVIGATION_CHANGEMOBILE";
  static const KEY_NAVIGATION_LOGIN = "KEY_NAVIGATION_LOGIN";

  static Future<void> navigate({
    @required String operation,
    @required String version,
    @required url,
    @required Function onSuccess,
    @required Function onError,
    @required Function onGoto,
  }) async {
    String result = await _channel.invokeMethod('navigate', {"operation": operation, "version": version, "url": url});
    Map<String, dynamic> response = jsonDecode(result);

    if (response["resultCode"] == "onSuccess") {
      onSuccess(response["result"]);
    } else if (response["resultCode"] == "onFail") {
      onError(response["result"]);
    } else if (response["resultCode"] == "onGoto") {
      onGoto(response["result"]);
    }
  }
}
